zoukankan      html  css  js  c++  java
  • HDU 1069 Monkey and Banana

    题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1069

    题目大意:给出n种方块的长宽高,每种方块无限多个,问你他们摞起来能达到的最大高度。每个方块都可以旋转,旋转的时候对应长宽高也改变,但是放的时候要求上面的长和宽必须小于下面的。

    解题思路:类似最长上升子序列,先排序,然后转移即可:

    dp[i]:= 以第i个为顶所形成的高度最大的块,其长和宽为第i个方块的长和宽,高度为最大高度
    dp[i] = max(dp[j]) + block[i]    j < i && block[i].x < dp[j].x && block[i].y < dp[j].y

    因为每种方块无限多个,所以将每一种拆成多个长宽高互换的即可。

    代码:

     1 const int inf = 0x3f3f3f3f;
     2 const int maxn = 505;
     3 struct block{
     4     int x, y, z;
     5 };
     6 block dp[maxn];
     7 vector<block> bls; 
     8 
     9 int cmp(block a, block b){
    10     if(a.x > b.x) return true;
    11     if(a.x == b.x) return a.y > b.y;
    12     return false;
    13 }
    14 
    15 int solve(){
    16     memset(dp, 0, sizeof(dp));
    17     sort(bls.begin(), bls.end(), cmp);
    18     int ans = 0, cnt = bls.size();
    19     dp[0].x = dp[0].y = inf; 
    20     for(int i = 1; i <= cnt; i++){
    21         dp[i].x = dp[i].y = inf; 
    22         for(int j = 0; j < i; j++){
    23             if(bls[i - 1].x < dp[j].x && bls[i - 1].y < dp[j].y){
    24                 if(bls[i - 1].z + dp[j].z > dp[i].z){
    25                     dp[i] = bls[i - 1]; dp[i].z += dp[j].z;
    26                     ans = max(ans, dp[i].z);
    27                 }
    28             } 
    29         }
    30     }
    31     return ans;
    32 }
    33 int main(){
    34     int n, t = 1;
    35     while(scanf("%d", &n) && n != 0){
    36         bls.clear();
    37         for(int i = 0; i < n; i++){
    38             int x, y, z;
    39             scanf("%d %d %d", &x, &y, &z);
    40             if(x < y) swap(x, y);
    41             if(x < z) swap(x, z);
    42             if(y < z) swap(y, z);
    43             block u; u.x = x; u.y = y; u.z = z;
    44             bls.push_back(u);
    45             if(x == y && x != z) {
    46                 swap(u.y, u.z);
    47                 bls.push_back(u);
    48             }
    49             else if(y == z && x != y){
    50                 swap(u.x, u.z);
    51                 bls.push_back(u);
    52             }
    53             else if(x != y && y != z && x != z){
    54                 swap(u.x, u.y); bls.push_back(u);
    55                 swap(u.x, u.z); bls.push_back(u);
    56                 swap(u.y, u.z); bls.push_back(u);
    57                 swap(u.x, u.y); bls.push_back(u);
    58                 swap(u.x, u.z); bls.push_back(u);
    59             }
    60         }
    61         int ans = solve();
    62         printf("Case %d: maximum height = ", t++);
    63         printf("%d
    ", ans);
    64     }
    65 }

    题目:

    Monkey and Banana

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 16088    Accepted Submission(s): 8546


    Problem Description
    A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

    The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height. 

    They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked. 

    Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
     
    Input
    The input file will contain one or more test cases. The first line of each test case contains an integer n,
    representing the number of different blocks in the following data set. The maximum value for n is 30.
    Each of the next n lines contains three integers representing the values xi, yi and zi.
    Input is terminated by a value of zero (0) for n.
     
    Output
    For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".
     
    Sample Input
    1 10 20 30 2 6 8 10 5 5 5 7 1 1 1 2 2 2 3 3 3 4 4 4 5 5 5 6 6 6 7 7 7 5 31 41 59 26 53 58 97 93 23 84 62 64 33 83 27 0
     
    Sample Output
    Case 1: maximum height = 40 Case 2: maximum height = 21 Case 3: maximum height = 28 Case 4: maximum height = 342
     
    Source
  • 相关阅读:
    繁忙的都市 最小生成树 入门题
    洛谷P2801 教主的魔法 分块
    洛谷 P3203 [HNOI2010]弹飞绵羊 分块
    洛谷P2607 [ZJOI2008]骑士 基环树动归
    Hdu 2586 树链剖分求LCA
    洛谷 P3384 【模板】树链剖分
    洛谷P1816 忠诚 分块
    最全前端开发面试问题及答案整理
    CSS垂直居中和水平居中
    实现一个图片懒加载插件有多难?
  • 原文地址:https://www.cnblogs.com/bolderic/p/7351373.html
Copyright © 2011-2022 走看看